codeforces 672D. Robin Hood(暴力)

D. Robin Hood
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

We all know the impressive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person has ci coins. Each day, Robin Hood will take exactly 1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's 1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire in k days. He decided to spend these last days with helping poor people.

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

Your task is to find the difference between richest and poorest persons wealth after k days. Note that the choosing at random among richest and poorest doesn't affect the answer.

Input

The first line of the input contains two integers n and k (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, the i-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

Output

Print a single line containing the difference between richest and poorest peoples wealth.

Examples
Input
4 1
1 1 4 2
Output
2
Input
3 1
2 2 2
Output
0
Note

Lets look at how wealth changes through day in the first sample.

  1. [1, 1, 4, 2]
  2. [2, 1, 3, 2] or [1, 2, 3, 2]

So the answer is 3 - 1 = 2

In second sample wealth will remain the same for each person.


题意:给你n个数,k次操作, 每次操作把最大的减一,最小的加一, 如果最大的减一变成最小的,就吧这减掉的1再加回去


直接暴力900多ms躺过,,,,生气


#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <stack>
#include <queue>
#include <set>
#include <map>
using namespace std;
const int inf = 2147483647;
const double PI = acos(-1.0);
const double e = 2.718281828459;
const int mod = 1000000007;
typedef long long LL;
#pragma comment(linker, "/STACK:102400000,102400000")
//freopen("in.txt","r",stdin); //输入重定向,输入数据将从in.txt文件中读取
//freopen("out.txt","w",stdout); //输出重定向,输出数据将保存在out.txt文件中cin
int a[500005];
map<LL, LL>mp;
set<int>st;
set<int>::iterator it, tt;
set<int>::reverse_iterator rt, rtt;

int main()
{
	int n, k, i, j;
	while (cin >> n >> k)
	{
		LL s = 0;
		mp.clear();
		st.clear();
		for (i = 1; i <= n; ++i)
		{
			scanf("%d", &a[i]);
			st.insert(a[i]);
			mp[a[i]]++;
			s += a[i] * 1LL;
		}
		sort(a + 1, a + 1 + n);
		LL x = s / n;
		LL y = s % n;
		LL num = 0;
		for (i = 1; i <= n; ++i)
		{
			LL xx = x;
			if (i >= n - y + 1)
				xx++;
			if (a[i] <= xx)
			{
				num += xx - a[i];
			}
		}
		if (k >= num)//如果k比num大,最后肯定是一种平衡状态,怎么操作都不会变了,要么是0,要么是1
		{
			if (y == 0)
				printf("0\n");
			else
				printf("1\n");
			
		}
		else
		{
			int k1 = k, k2 = k;
			int mmin, mmax;
			for (it = ++st.begin(); it != st.end(); ++it)//正着跑一边,看k次操作后的最小值是多少
			{
				tt = --it;
				++it;
				if (mp[*tt] * (*it - *tt) * 1LL > k1 )//注意两个相乘可能爆int,所以map直接longlong即可
				{
					mmin = (*tt + k1 / mp[*tt]);
					break;
				}
				else if (mp[*tt] * (*it - *tt) * 1LL == k1)
				{
					mmin = *it;
					break;
				}
				else
				{
					k1 -= mp[*tt] * (*it - *tt);
					mp[*it] += mp[*tt];
				}
			}
			for (rt = st.rbegin(); rt != --st.rend(); ++ rt)//反着跑一边求出最大值
			{
				rtt = ++rt;
				--rt;
				if (mp[*rt] * (*rt - *rtt) * 1LL > k2)
				{
					mmax = *rt - (k2 / mp[*rt]);
					break;
				}
				else if (mp[*rt] * (*rt - *rtt) * 1LL == k2)
				{
					mmax = *rtt;
					break;
				}
				else
				{
					k2 -= mp[*rt] * (*rt - *rtt);
					mp[*rtt] += mp[*rt];
				}
			}
			printf("%d\n", mmax - mmin);
		}


	}
}




CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值